/*
 * @(#)FreecivConstants.java - Just a constant data holder
 *
 *
 * Created on July 28, 2000, 3:57 PM
 */

/**
 *
 * @author  furyhawk <lookmeow@magix.com.sg>
 * @author  Michael Grundel <michael42@grundel.de>
 * @author  Raimar Falke <rf13@inf.tu-dresden.de>
 * @version 0.04
 */

/**
   ********************************************************************
 CivLog - Copyleft (C) 2000 - Wong Teck Meng
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.
 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
**********************************************************************
                                                                      */
package org.freeciv.civlog;

import java.util.Hashtable;

public class FreecivConstants
{
    private static Hashtable validTypeNames=null;

    // number of defined data types
    public static final int NUMBER_OF_DATA_TYPES = 27;

    // data types
    public static final int POP         = 0;
    public static final int BNP         = 1;
    public static final int MFG         = 2;
    public static final int CITIES      = 3;
    public static final int TECHS       = 4;
    public static final int MUNITS      = 5;
    public static final int SETTLERS    = 6;
    public static final int WONDERS     = 7;
    public static final int TECHOUT     = 8;
    public static final int LANDAREA    = 9;
    public static final int SETTLEDAREA = 10;
    public static final int POLLUTION   = 11;
    public static final int LITERACY    = 12;
    public static final int SPACESHIP   = 13;
    public static final int GOLD        = 14;
    public static final int TAXRATE     = 15;
    public static final int SCIRATE     = 16;
    public static final int LUXRATE     = 17;
    public static final int RIOTS       = 18;
    public static final int HAPPYPOP    = 19;
    public static final int CONTENTPOP  = 20;
    public static final int UNHAPPYPOP  = 21;
    public static final int TAXMEN      = 22;
    public static final int SCIENTISTS  = 23;
    public static final int ELVIS       = 24;
    public static final int GOV         = 25;
    public static final int CORRUPTION  = 26;

    public static final int[] DATA_TYPES = { POP, BNP, MFG, CITIES,
                                           TECHS, MUNITS, SETTLERS,
                                           WONDERS, TECHOUT, LANDAREA,
                                           SETTLEDAREA, POLLUTION,
                                           LITERACY, SPACESHIP, GOLD,
                                           TAXRATE, SCIRATE, RIOTS,
                                           HAPPYPOP, CONTENTPOP,
                                           UNHAPPYPOP, TAXMEN,
                                           SCIENTISTS, ELVIS,
                                           GOV, CORRUPTION};

    public static final String[] DATA_SCOREFILE_NAME =
        { "pop", "bnp", "mfg", "cities", "techs", "munits", "settlers",
          "wonders", "techout", "landarea", "settledarea", "pollution",
          "literacy", "spaceship", "gold", "taxrate", "scirate", "luxrate",
          "riots", "happypop", "contentpop", "unhappypop", "taxmen",
          "scientists", "elvis", "gov", "corruption"
        };

    /** labels on the JCheckBoxes
     */
    public static final String[] DATA_TEXT =
        { "Population", "BNP", "Manufacturing", "Cities", "Technologies",
          "Military Units", "Settlers",
          "Wonders", "Techout", "Land Area", "Settled Area",
          "Pollution", "Literacy", "Spaceship",
          "Gold", "Tax rate", "Science rate", "Luxury rate",
          "Riots", "Happy Pop", "Content Pop", "Unhappy Pop",
          "Taxmen", "Scientists", "Elvis", "Government", "Corruption"};

    /** description shown in the graph
     *  DATA_DESCRIPTION[i] describes data type i
     */
    public static final String[] DATA_DESCRIPTION =
        { "Population", "BNP", "Manufacturing", "Cities", "Technologies",
          "Military Units", "Settlers",
          "Wonders", "Tech Output", "Land Area", "Settled Area",
          "Pollution", "Literacy", "Spaceship",
          "Gold", "Tax rate", "Science rate", "Luxury rate",
          "Rioting cities", "Happy population", "Content population",
          "Unhappy population", "Taxmen", "Scientists", "Elvis", 
          "Government: 0 Anarchy, 1 Despotism, 2 Monarchy, 3 Communism, 4 Republic, 5 Democracy", 
          "Corruption"
        };

    /** tool-tips on the JCheckBoxes
     */
    public static final String[] DATA_TOOL_TIPS =
        { "Population size", "Trade", "Shield surplus",
          "Number of cities", "steeper means: faster research",
          "Number of military units", "Number of settlers",
          "Number of wonders", "Number of breaker flasks?",
          "Land area explored", "Settled area", "Pollution",
          "Population with access to a library or university", "Number of space modules made",
          "Gold in the bank", "Tax rate", "Science rate", "Luxury rate",
          "Number of cities rioting", "Happy population", "Content population", 
          "Unhappy population", "Number of taxmen", "Number of scientists", "Number of \"Elvis\"",
          "Form of government", "Trade lost due to corruption" };

    public static final char[] DATA_MNEMONICS =
        { 'p', 'b', 'm', 'c', 't', 'u', 's', 'w', 'o', 'l', 'a', 'i' ,'y',
          'h', 'g', 'x', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.',
          '.', '.', '.', '.', '.'
        };

    public static final boolean[] DATA_PER_CITY =
        { true,true,true,false,false,
          true,true,
          true,true,true,true,
          true,false,false,
          true,false,false,false,
          true,true,true,true,
          true,true,true,
          false,true
        };

    public static boolean isValidTypeName(String abc)
    {
        ensureInit();
        return validTypeNames.containsKey(abc);
    }

    private static void ensureInit()
    {
        if(validTypeNames!=null)
            return;

        validTypeNames=new Hashtable();

        for(int i=0;i<DATA_SCOREFILE_NAME.length;i++)
            validTypeNames.put(DATA_SCOREFILE_NAME[i],"dummy");
    }
}
// End of FreecivConstants.java
