/*
 * @(#)dlgTextBox.java - a multi purpose text area dialog
 *
 * Created on September 1, 2000, 2:27 PM
 */


/**
 *
 * @author  furyhawk <lookmeow@magix.com.sg>
 * @version 0.2
 */

/**
   ********************************************************************
 CivLog - Copyleft (C) 2000 - Wong Teck Meng
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.
 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
**********************************************************************
                                                                      */

package org.freeciv.civlog.gui;

import java.io.*;
import java.awt.*;

import org.freeciv.civlog.Debug;
import org.freeciv.civlog.CivLog;

public class dlgTextBox extends javax.swing.JDialog
{

    /**
    * Creates new form dlgTextBox
    * @param parent Parent frame
    * @param modal Is a modal dialog?
    * @param dimension Size of the Text Box
    */
    public dlgTextBox (java.awt.Frame parent,boolean modal, Dimension dimension, File textFile)
    {
        super (parent, modal);
        Debug.trace ( "dlgHelp.dlgHelp: initializing......." );
        initComponents ();

        setTitle (CivLog.PROGRAMNAME + textFile.getName () );
        loadText (textFile);

        setSize(dimension.width, dimension.height);

        Debug.trace ( "dlgHelp.dlgHelp: done" );
    }

    void loadText (File theFile)
    {
        try
        {
            String line;

            /** FIXME: problem with the directory used to open the file */
            BufferedReader in = new BufferedReader (new FileReader (theFile));

            /** Clear clear the default text */
            jtxtaHelpText.setText ("");

            for (;;)
            {
                line = in.readLine ();
                if (line==null)
                    break;
                /** add gutter and line feed */
                jtxtaHelpText.append ("  "+line);
                jtxtaHelpText.append ("\n");
            }

            in.close ();
        }
        catch (IOException e)
        {
            e.printStackTrace ();
        }

        /** Set the caret back to the beginning of line */
        jtxtaHelpText.setCaretPosition (0);

        Debug.trace ( "dlgHelp.loadHelpText: finish" );
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents ()//GEN-BEGIN:initComponents
    {
        jbtnOK = new javax.swing.JButton ();
        jsclpHelpText = new javax.swing.JScrollPane ();
        jtxtaHelpText = new javax.swing.JTextArea ();
        addWindowListener (new java.awt.event.WindowAdapter ()
                           {
                               public void windowClosing (java.awt.event.WindowEvent evt)
                               {
                                   closeDialog (evt);
                               }
                           }
                          );

        jbtnOK.setText ("OK");
        jbtnOK.addActionListener (new java.awt.event.ActionListener ()
                                  {
                                      public void actionPerformed (java.awt.event.ActionEvent evt)
                                      {
                                          jbtnOKActionPerformed (evt);
                                      }
                                  }
                                 );


        getContentPane ().add (jbtnOK, java.awt.BorderLayout.SOUTH);


        jtxtaHelpText.setLineWrap (true);
        jtxtaHelpText.setEditable (false);
        jtxtaHelpText.setFont (new java.awt.Font ("Courier New", 0, 12));
        jtxtaHelpText.setText ("Loading Help Text...........\\nFile not found if you see this box for more then 10 sec");

        jsclpHelpText.setViewportView (jtxtaHelpText);


        getContentPane ().add (jsclpHelpText, java.awt.BorderLayout.CENTER);

    }//GEN-END:initComponents

    private void jbtnOKActionPerformed (java.awt.event.ActionEvent evt)
    {//GEN-FIRST:event_jbtnOKActionPerformed
        setVisible (false);
        dispose ();
    }//GEN-LAST:event_jbtnOKActionPerformed

    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt)
    {//GEN-FIRST:event_closeDialog
        setVisible (false);
        dispose ();
    }//GEN-LAST:event_closeDialog

    /**
    * @param args the command line arguments
    */
    //public static void main (String args[]) {
    //new dlgTextBox (new javax.swing.JFrame (), true);
    //}


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jbtnOK;
    private javax.swing.JScrollPane jsclpHelpText;
    private javax.swing.JTextArea jtxtaHelpText;
    // End of variables declaration//GEN-END:variables

}
// End of dlgTextBox.java
